import numpy as np
import random as rnd

def dump_mat_screen(game_mat):
    # This function is for printing game matrix.
    # it takes matrix as a parameter and do esnot return anything. just produce screen message
    # game_mat consist of number -1 means the cell which have not open yet
    # zero means the guess is correct
    # other numbers shows the distance between mouse and guess


    n,m=game_mat.shape
    # to write first row number
    print("   ",end='')
    for i in range(1,m+1):
        print("%3d" % i,end='')
    print("")
    # to write main matrix
    for i in range(0,n):
        print("%3d" % (i+1),end='')
        for j in range(0,m):
            if game_mat[i,j]==-1: # if it is -1 then print 0
                print("%3d" % 0,end='')
            elif game_mat[i,j]==0: # if it is 0 then print X as it is found
                print("%3s" % "X",end='')
            else:
                print("%3d" % (game_mat[i,j]),end='') # unless print the number which shows distance
        print("")
    print("")
    


def process_guess(game_mat, mouse,guess,mov):
    # this function proces the given guess command on to the game matrix.
    
        
    if mov==1: # if mouse is move then first change its location
        r=rnd.randint(0,3) # generate one of 4 different movement for mouse
        if r==0 and mouse[0]+1<game_mat.shape[0]: # mouse move down
            mouse[0]+=1
        elif r==1 and mouse[0]-1>=0: # mouse move up
            mouse[0]-=1
        elif r==2 and mouse[1]+1<game_mat.shape[1]:  # mouse move left
            mouse[1]+=1
        elif r==3 and mouse[1]-1>=0: # mouse move right
            mouse[1]-=1
    # calculate distance between guess and mouse location
    dist=abs(mouse[1]-guess[1])+abs(mouse[0]-guess[0])
    # set certain game matrix as with distance
    game_mat[guess[0],guess[1]]=dist
    # return game matrix mouse location and found distance
    return game_mat,mouse,dist


def save_last_game(game_mat,mouse,attemp,maxattempt,mov):
    # this function save the last game into file

    f=open("MouseHunter.txt","w")
    n,m=game_mat.shape
    f.write(str(n)+"\n")
    f.write(str(m)+"\n")
    f.write(str(mouse[0])+"\n")
    f.write(str(mouse[1])+"\n")
    f.write(str(attemp)+"\n")
    f.write(str(maxattempt)+"\n")
    f.write(str(mov)+"\n")
    for i in range(0,n):
        for j in range(0,m):
            f.write("%d "%game_mat[i,j])       
    f.close()

def load_last_game():
    # this function load the last saved game from file
    f=open("MouseHunter.txt","r")
    n=int(f.readline())
    m=int(f.readline())
    mx=int(f.readline())
    my=int(f.readline())
    attemp=int(f.readline())
    maxattempt=int(f.readline())
    mov=int(f.readline())
    gamemat=f.read()
    game=gamemat.split(" ")
    game_mat=-1*np.ones((n,m))
    mouse=[mx,my]
    cnt=0
    for i in range(0,n):
        for j in range(0,m):
            game_mat[i,j]=int(game[cnt])
            cnt+=1
    f.close()
    return game_mat,mouse,attemp,maxattempt,mov

def create_new_game():
    # this function create new game as the user wish.

    mov=int(input("Is mouse moving? 1 for moving mouse 0 for fixed mouse: ")) 
    n=int(input("Give number of Rows: "))    
    m=int(input("Give number of Cols: ")) 
    maxattempt=int(input("Give number of maximum attempts: ")) 
    game_mat=-1*np.ones((n,m))
    mouse=[rnd.randint(0,n-1),rnd.randint(0,m-1)]
    attemp=0
    return game_mat,mouse,attemp,maxattempt,mov

def play_game(game_mat,mouse,attemp,maxattempt,mov):
    # This function is the main function for game playing it takes all game parameter and perform the game
    
    # set initial distance
    dist=1
    # isbreak is for if the user wants to break the game or not
    isbreak=False
    # during we have an attempt left and we could not find the mouse yet and the user do not want to break the game yet
    while attemp< maxattempt and dist>0 and not isbreak:
        # print the game matrix
        dump_mat_screen(game_mat)
        # increase attempt
        attemp+=1
        # take guess as inputs
        print("Guess %3d out of %3d..." %(attemp,maxattempt))
        print("To calcel and save the game please give 0 for x or y guess")
        x=int(input("Guess Row: "))    
        y=int(input("Guess Col: ")) 
        # if the given guess in the range then perform it
        if (x>0 and x<= game_mat.shape[0] and y>0 and y<= game_mat.shape[1]): 
            # set guess array nd perform it           
            guess=[x-1,y-1]
            game_mat,mouse,dist=process_guess(game_mat, mouse,guess,mov)
        else:
            # else means the user wants to break the game
            attemp-=1
            isbreak=True
    if dist==0: # it means the mouse is found
        # print the game matrix and appropriate message
        dump_mat_screen(game_mat)
        print("Congragulations! You cought the mouse in %d moves" % attemp)

    elif attemp== maxattempt: # if we reach the maximum attempts
        dump_mat_screen(game_mat)
        print("Unfortunatelly, You lost the game")
    else: # if the user wants to break the game then save the last game
        print("You have abandoned the game it was saved you can continue if you want")
        save_last_game(game_mat,mouse,attemp,maxattempt,mov)


n='y'

while n=='y' or n=='Y':

    n=input("Do you want to load previous game ? y/n ")
    if n=='y' or n=='Y':
        game_mat,mouse,attemp,maxattempt,mov=load_last_game()
    else:
        game_mat,mouse,attemp,maxattempt,mov=create_new_game()

    play_game(game_mat,mouse,attemp,maxattempt,mov)

    n=input("Do you want to continue ? y/n ")




